SystemOrganization addCategory: #'A4BP-Tests-SimEngine-BPMN20'!

TestCase subclass: #BPMN20ExecutionVisitorTest
	instanceVariableNames: 'bpmnMetamodel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPMN20ExecutionVisitorTest methodsFor: 'setUp' stamp: 'AlvaroJosePeraltaOcampo 3/10/2015 14:48'!
configExecution
	|parser|
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.! !

!BPMN20ExecutionVisitorTest methodsFor: 'testRuning' stamp: 'AlvaroJosePeraltaOcampo 3/17/2015 00:09'!
testProcessValidation

	|execution grabber parser inputScenario bpsimdata|
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	execution := BPSimBPMN20ExecutionVisitor new.
	grabber := BPSimBPMN20TimeVisitor new.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.
	inputScenario := bpsimdata scenarios first.
	execution addGrabber: grabber.
	execution addInputScenario: inputScenario.
	execution addOutputScenario: BPSimScenario new.
	execution addProcessModel: bpmnMetamodel.
	execution runSimulation.
	
	self assert: grabber processingTime = 30.! !

!BPMN20ExecutionVisitorTest methodsFor: 'testRuning' stamp: 'AlvaroJosePeraltaOcampo 3/17/2015 00:09'!
testTimeValidation

	|execution grabber parser inputScenario bpsimdata|
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	execution := BPSimBPMN20ExecutionVisitor new.
	grabber := BPSimBPMN20TimeVisitor new.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.
	inputScenario := bpsimdata scenarios first.
	
	execution addGrabber: grabber.
	execution addInputScenario: inputScenario.
	execution addOutputScenario: BPSimScenario new.
	execution addProcessModel: bpmnMetamodel.
	execution runSimulation.
	
	self assert: grabber processingTime = 30.
! !

!BPMN20ExecutionVisitorTest methodsFor: 'testRuning' stamp: 'AlvaroJosePeraltaOcampo 3/17/2015 00:09'!
testTsunamiv3TimeValidation

	|execution grabber parser inputScenario simb task|
	
	parser := BPMN20Parser parseString: BPMN20SampleTsunamiResonponse tsunamiv3.
	bpmnMetamodel := (parser definitions first process select:[:p | p aName = 'Réponse tsunami au VN']) values first.
	
	execution := BPSimBPMN20ExecutionVisitor new.
	grabber := BPSimBPMN20TimeVisitor new.
	
	simb := BPSimBuilder new.
	simb buildScenarioId: 'tsunamiInputScenario'.
	
	task := (bpmnMetamodel activities select: [ :a | a class = BPMN20TaskImpl  ]).
	simb timer processingParameters: task config:[ :t |
			| p |
			p := BPSimDurationParameter new.
			p value: 10.
			p 
		].
		
	inputScenario := simb bpsimScenario.
	
	execution addGrabber: grabber.
	execution addInputScenario: inputScenario.
	execution addOutputScenario: BPSimScenario new.
	execution addProcessModel: bpmnMetamodel.
	execution runSimulation.
	
	"With 10 for each task activity"
	self assert: grabber processingTime = 200.
! !

TestCase subclass: #BPSimBPMN20EngineProcessTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'A4BP-Tests-SimEngine-BPMN20'!

!BPSimBPMN20EngineProcessTest methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/17/2015 00:10'!
testrunTimerSimulation
	| bpSimEngine parser bpmnMetamodel bpsimdata | 
	
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.
	
	bpSimEngine := BPSimBPMN20EngineProcess new.
	bpSimEngine addProcessModel: bpmnMetamodel.
	bpSimEngine addInputScenario: bpsimdata inputScenario.
	
	bpSimEngine runTimerSimulationUsing:  bpsimdata inputScenario.
	
	bpSimEngine outputScenarios ! !

!BPSimBPMN20EngineProcessTest methodsFor: 'as yet unclassified' stamp: 'AlvaroJosePeraltaOcampo 3/17/2015 00:18'!
testrunTimerSimulations
	| bpSimEngine bpmnMetamodel bpsimdata parser inprocess|
	
	bpSimEngine := BPSimBPMN20EngineProcess new.
	parser := BPMN20Parser parseString: BPMN20SampleVerySimpleProcess bpmn02.
	bpmnMetamodel := parser definitions first process values first.
	bpsimdata := BPSimParser parseString: BPMN20SampleVerySimpleProcess bpmn02WithSim.


	bpSimEngine addProcessModel: bpmnMetamodel.
	inprocess := 50.
	bpSimEngine runTimerSimulationUsing:bpsimdata inputScenario for: inprocess.
	(Delay forSeconds: 2) wait.
		
	self assert: bpSimEngine outputScenarios notNil.
	self assert: bpSimEngine outputScenarios size = inprocess.

	bpSimEngine outputScenarios do:[ :s | 
		self assert:  s processTime = 30 ]
	! !
